/////////////////////////////////////
//  cWRg[   output.c  //
//  2010/05/17  PIC16F88 MikroC    //
/////////////////////////////////////

#include "global.h"

#define STOP        0
#define START       1
#define RUN         2
#define END_LED     3
#define END_BUZZER  4

static uchar state;

void out_init(void){
  state = STOP;
}

void all_clear(void){
    timer_cancel(TIMER_PERIOD);
    timer_cancel(TIMER_OUT);
    timer_cancel(TIMER_LED_BLINK);
    startB = 0;
    startF = 0;
    PORTB = 0x4;             //dLED̂
    state = STOP;
}

void output(void){
     int duty;
     
     duty = ad_res;
     duty += 8;
     if(!PORTA.F4)duty = duty >> 1;
     if(timer_check_start(TIMER_PERIOD)){
        timer_cancel(TIMER_OUT);
        PORTB.F1 = 1;
        PORTB.F3 = 1;
        timer_start(TIMER_OUT,duty);
    }
    if(timer_check(TIMER_OUT)){
        if(duty < 0x3ff){
            PORTB.F1 = 0;
            PORTB.F3 = 0;
        }
    }
}

void sequence(void){
    switch(state){
        case STOP:
            PORTB = 0x4;
            if(startB){
                state = START;
                startB = 0;
            }
            break;
        case START:
            timer_start(TIMER_PERIOD, 1024);
            state = RUN;
            m_tics = 0;
            minute = 0;
            break;
        case RUN:
            output();
            if(!startF){
                all_clear();
                return;
            }
            if(startB){
                startB = 0;
                m_tics = 0;
                minute = 0;
            }
            if((set_time - minute) < 4){
                timer_start(TIMER_LED_BLINK, 500);
                state = END_LED;
            }
            break;
        case END_LED:
            output();
            if(!startF){
                all_clear();
                return;
            }
            if(startB){
                startB = 0;
                m_tics = 0;
                minute = 0;
                timer_cancel(TIMER_LED_BLINK);
                PORTB.F4 = 0;
                state = RUN;
                return;
            }
            if(timer_check_start(TIMER_LED_BLINK))PORTB.F4 = ~PORTB.F4;
            if(set_time <= minute){
                timer_start(TIMER_END,5000);
                timer_cancel(TIMER_LED_BLINK);
                PORTB.F4 = 0;
                PORTB.F3 = 0;
                PORTB.F1 = 0;
                state = END_BUZZER;
                startF = 0;
            }
            break;
        case END_BUZZER:
            CCP1CON = 0xC;      //PWM
            PR2 = 0x7f;         //period
            CCPR1L = 0x40;      //duty
            T2CON = 0x5;        //pre1/4 T2ON
            if(timer_check(TIMER_END)){
                T2CON = 0;      //T2OFF
                state= STOP;
            }
            break;
    }
}
