///////////////////////////////////////
//  cWRg[[  solder2.c  //
//  2010/05/13  PIC16F88  MikroC     //
///////////////////////////////////////

//CLOCK 8MHz
// _FCMEM_OFF, _IESO_OFF, _BOD_ON, _CPD_OFF, _CP_OFF,
// _MCLEAR_OFF, _WDT_OFF, _INTRC_IO, CCP1_RB0

#include "global.h"

#define OFF     0
#define OFFtoON 1
#define ON_PLS  2
#define ON      3
#define ONtoOFF 4

uchar startF;       //start flag
uchar startB;        //start BUTTON
uchar set_time;     //
static uchar set_time_now;
static uchar state;

void input(void) {
    if(!timer_check_start(TIMER_INP)) return;
    if(PORTA.F2 && PORTA.F3) set_time_now = 20;
    else if(PORTA.F3) set_time_now = 40;
    else if(PORTA.F2) set_time_now = 60;
    if(set_time_now != set_time) startF = 0;    //rŎԂςIt
    switch(state){
        case OFF:
            if(!PORTA.F1)state = OFFtoON;
            break;
        case OFFtoON:
            if(!PORTA.F1)state = ON_PLS;
            else state = OFF;
            break;
        case ON_PLS:
            set_time = set_time_now;
            startF = 1;
            startB = 1;
            state = ON;
        case ON:
            if(PORTA.F1)state = ONtoOFF;
            break;
        case ONtoOFF:
            if(PORTA.F1)state = OFF;
            else state =  ON;
            break;
     }
}

void main(void)
{   OSCCON = 0x72;      //INTR 8MHz
    OPTION_REG = 0xc0;  //prescale = t0;
    WDTCON = 0x17;      //1/65536 ,2S ,ENABLE
    asm CLRWDT;         //WDT CLR
    TRISA = 0x3f;
    TRISB = 0xc0;
    PORTB = 0;
    PORTB.F2 = 1;       //d\
    timer_init();
    ad_init();
    out_init();
    state = OFF;
    startF = startB = set_time = 0;
    timer_start(TIMER_INP,50);
    while(1){
        asm CLRWDT;     //WDT CLR
        ad_conv();
        input();
        sequence();
    }
}
