/////////////////////////////////////
//  cWRg[[  timer.c  //
//  2010/05/13  PIC16F88  MikroC   //
/////////////////////////////////////

#include "global.h"

static  uint set_time[TIMER_NUM];   //^C}[ݒ莞Ԃ̔z
static  uint start_time[TIMER_NUM]; //^C}[JnԂ̔z
static volatile uint tics;          //1mSJE^
volatile uint m_tics;               //PpJE^
volatile uchar minute;              //JE^

void timer_init(void){
    int n;

    for(n = 0; n < TIMER_NUM; n++) set_time[n] = 0;
    TMR1H = 0xf8;                   //Timer1 l
    TMR1L = 0x3f;                   //2f + 10iI[o[wbhj
    T1CON = 0x1;                    //Timer1 ,ps1/1,enable
    PIE1.TMR1IE = 1;                //Timer1 荞݉
    INTCON.PEIE = 1;                //ӊ荞݉
    INTCON.GIE = 1;                 //S荞݉
}

void timer_start(int num, uint time){
    if(set_time[num]) return;
    set_time[num] = time;
    start_time[num] = tics;
}

void timer_restart(int num, uint time){
    set_time[num] = time;
    start_time[num] = tics;
}

void timer_cancel(int num){
    set_time[num] = 0;
}

int timer_check(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    set_time[num] = 0;
    return 1;
}

int timer_check_start(int num){
    if (!set_time[num]) return 0;
    if (tics - start_time[num] < set_time[num]) return 0;
    start_time[num] = tics;
    return 1;
}

void interrupt(){       //1mS荞
    PIR1.TMR1IF = 0;    //荞݃tONA
    TMR1H = 0xf8;       //Timer1 l
    TMR1L = 0x3f;       //2f + 10iI[o[wbhj
    tics++;
    if(startf) m_tics ++;
    if(m_tics >= 60000){
        minute ++;
        m_tics = 0;
    }
}
